{ kontroll.pas                                                              }
{ 2001-03-31 programmeerimisolmpiaadi 3. lesande testija                  }
{    TORUD                                                                  }
{ Ahto Truu                                                                 }

{$I-}

const
   max = 100;

type
   punkt = record
      x, y : integer;
   end;
   nelik = record
      p1, p2, p3, p4 : punkt;
   end;

{ arvutab kahe punkti vahelise kauguse ruudu }
function kaug_ruut (var p1, p2 : punkt) : longint;
var dx, dy : longint;
begin
   dx := p1.x - p2.x; dy := p1.y - p2.y;
   kaug_ruut := sqr (dx) + sqr (dy);
end;

{ kontrollib, kas punktinelik moodustab ruudu }
function on_ruut (var x : nelik) : boolean;
var a1, a2, a3, a4, d1, d2 : longint;
begin
   a1 := kaug_ruut (x.p1, x.p2);
   a2 := kaug_ruut (x.p2, x.p3);
   a3 := kaug_ruut (x.p3, x.p4);
   a4 := kaug_ruut (x.p4, x.p1);
   d1 := kaug_ruut (x.p1, x.p3);
   d2 := kaug_ruut (x.p2, x.p4);
   on_ruut := (a1 = a2) and (a2 = a3) and (a3 = a4) and (d1 = d2);
end;

var
   f : text;
   n : integer;
   r, r1 : integer;
   rt : array [1..max] of boolean;
   kr : array [1..max] of longint;
   k, k1 : integer;
   i, j, j1 : integer;
   t : boolean;
   x : nelik;

begin
   if paramcount <> 2 then begin
      writeln ('Sntaks on: ', paramstr (0), ' sisendfail vljundfail');
      halt (1);
   end;

   { loeme sisendandmed ja leiame ruudud }
   assign (f, paramstr (1)); reset (f);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (1), ' avamisel');
      halt (1);
   end;

   readln (f, n);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (1), ' lugemisel');
      halt (1);
   end;

   r := 0;
   for i := 1 to n do begin
      readln (f,
         x.p1.x, x.p1.y,
         x.p2.x, x.p2.y,
         x.p3.x, x.p3.y,
         x.p4.x, x.p4.y);
      if ioresult > 0 then begin
         writeln ('Viga faili ', paramstr (1), ' lugemisel');
         halt (1);
      end;

      rt[i] := on_ruut (x);
      if rt[i] then begin
         kr[i] := kaug_ruut (x.p1, x.p2);
         r := r + 1;
      end;
   end;

   close (f);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (1), ' lugemisel');
      halt (1);
   end;

   { loendame erinevad ruudud }
   k := 0;
   for i := 1 to n do
      if rt[i] then begin
         t := true;
         for j := 1 to i - 1 do
            if rt[j] and (kr[j] = kr[i]) then
               t := false;
         if t then
            k := k + 1;
      end;

   { loeme vistleja vastuse }
   assign (f, paramstr (2)); reset (f);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (2), ' avamisel');
      halt (1);
   end;

   readln (f, r1);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (2), ' lugemisel');
      halt (1);
   end;

   if r1 = r then
      writeln ('Ruutude arv ', r1, ' ige')
   else
      writeln ('*** Ruutude arv ', r1, ' vale (peaks olema ', r, ')');

   readln (f, k1);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (2), ' lugemisel');
      halt (1);
   end;

   if k1 = k then
      writeln ('Jada pikkus ', k1, ' ige')
   else
      writeln ('*** Jada pikkus ', k1, ' vale (peaks olema ', k, ')');

   for i := 1 to k1 do begin
      read (f, j);
      if ioresult > 0 then begin
         writeln ('Viga faili ', paramstr (2), ' lugemisel');
         halt (1);
      end;

      if (j < 1) or (j > n) then begin
         writeln ('*** Lubamatu toru number ', j);
         halt (1);
      end;

      if not rt[j] then begin
         writeln ('*** Mitteruudukujulise toru number ', j);
         halt (1);
      end;

      if i > 1 then
         if not (kr[j1] > kr[j]) then begin
            writeln ('*** Toru number ', j, ' ei mahu toru number ', j1, ' sisse');
            halt (1);
         end;

      j1 := j;
   end;

   if not seekeof (f) then begin
      writeln ('*** Liigne lbu faili ', paramstr (2), ' lpus');
      halt (1);
   end;

   close (f);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (2), ' lugemisel');
      halt (1);
   end;

   writeln ('OK');
end.